(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tui-editor'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-wysiwyg-markdown-editor', ['exports', 'tui-editor', '@angular/core'], factory) :
    (factory((global['ngx-wysiwyg-markdown-editor'] = {}),global.Editor,global.ng.core));
}(this, (function (exports,Editor,i0) { 'use strict';

    Editor = Editor && Editor.hasOwnProperty('default') ? Editor['default'] : Editor;

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-wysiwyg-md-editor.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxWysiwygMdEditorService = /** @class */ (function () {
        function NgxWysiwygMdEditorService() {
        }
        NgxWysiwygMdEditorService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxWysiwygMdEditorService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxWysiwygMdEditorService.ngInjectableDef = i0.ɵɵdefineInjectable({ factory: function NgxWysiwygMdEditorService_Factory() { return new NgxWysiwygMdEditorService(); }, token: NgxWysiwygMdEditorService, providedIn: "root" });
        return NgxWysiwygMdEditorService;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-wysiwyg-md-editor.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxWysiwygMdEditorComponent = /** @class */ (function () {
        function NgxWysiwygMdEditorComponent() {
        }
        /**
         * @return {?}
         */
        NgxWysiwygMdEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        NgxWysiwygMdEditorComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'lib-ngx-wysiwyg-md-editor',
                        template: "\n    <p>\n      ngx-wysiwyg-md-editor works!\n    </p>\n  "
                    }] }
        ];
        /** @nocollapse */
        NgxWysiwygMdEditorComponent.ctorParameters = function () { return []; };
        return NgxWysiwygMdEditorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-wysiwyg-md-editor.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WysiwygMdEditorDirective = /** @class */ (function () {
        function WysiwygMdEditorDirective(element) {
            this.element = element;
            this.valueChange = new i0.EventEmitter();
            this.display = 'block';
            this.defaults = {
                el: this.element.nativeElement,
                initialValue: '',
                initialEditType: 'wysiwyg',
                previewStyle: 'vertical',
                height: '300px'
            };
        }
        /**
         * @return {?}
         */
        WysiwygMdEditorDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var options = Object.assign(this.defaults, {
                    initialValue: this.initialValue || this.defaults.initialValue,
                    initialEditType: this.editType || this.defaults.initialEditType,
                    height: this.height || this.defaults.height,
                    previewStyle: this.previewStyle || this.defaults.previewStyle,
                });
                this.editor = new Editor(options);
                this.editor.on('change', ( /**
                 * @return {?}
                 */function () {
                    _this.valueChange.emit(_this.editor.getValue());
                }));
            };
        /**
         * @return {?}
         */
        WysiwygMdEditorDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.editor.off('change');
                this.editor.remove();
            };
        WysiwygMdEditorDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'ngxWysiwygMdEditor, [ngxWysiwygMdEditor]'
                    },] }
        ];
        /** @nocollapse */
        WysiwygMdEditorDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef }
            ];
        };
        WysiwygMdEditorDirective.propDecorators = {
            initialValue: [{ type: i0.Input }],
            editType: [{ type: i0.Input }],
            height: [{ type: i0.Input }],
            previewStyle: [{ type: i0.Input }],
            valueChange: [{ type: i0.Output }],
            display: [{ type: i0.HostBinding, args: ['style.display',] }]
        };
        return WysiwygMdEditorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-wysiwyg-md-editor.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxWysiwygMdEditorModule = /** @class */ (function () {
        function NgxWysiwygMdEditorModule() {
        }
        NgxWysiwygMdEditorModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [NgxWysiwygMdEditorComponent, WysiwygMdEditorDirective],
                        imports: [],
                        exports: [NgxWysiwygMdEditorComponent, WysiwygMdEditorDirective]
                    },] }
        ];
        return NgxWysiwygMdEditorModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-wysiwyg-markdown-editor.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgxWysiwygMdEditorService = NgxWysiwygMdEditorService;
    exports.NgxWysiwygMdEditorComponent = NgxWysiwygMdEditorComponent;
    exports.WysiwygMdEditorDirective = WysiwygMdEditorDirective;
    exports.NgxWysiwygMdEditorModule = NgxWysiwygMdEditorModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-wysiwyg-markdown-editor.umd.js.map