import Editor from 'tui-editor';
import { Injectable, Component, Directive, Input, Output, EventEmitter, ElementRef, HostBinding, NgModule, ɵɵdefineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-wysiwyg-md-editor.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxWysiwygMdEditorService = /** @class */ (function () {
    function NgxWysiwygMdEditorService() {
    }
    NgxWysiwygMdEditorService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxWysiwygMdEditorService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxWysiwygMdEditorService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxWysiwygMdEditorService_Factory() { return new NgxWysiwygMdEditorService(); }, token: NgxWysiwygMdEditorService, providedIn: "root" });
    return NgxWysiwygMdEditorService;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-wysiwyg-md-editor.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxWysiwygMdEditorComponent = /** @class */ (function () {
    function NgxWysiwygMdEditorComponent() {
    }
    /**
     * @return {?}
     */
    NgxWysiwygMdEditorComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    NgxWysiwygMdEditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-ngx-wysiwyg-md-editor',
                    template: "\n    <p>\n      ngx-wysiwyg-md-editor works!\n    </p>\n  "
                }] }
    ];
    /** @nocollapse */
    NgxWysiwygMdEditorComponent.ctorParameters = function () { return []; };
    return NgxWysiwygMdEditorComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-wysiwyg-md-editor.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var WysiwygMdEditorDirective = /** @class */ (function () {
    function WysiwygMdEditorDirective(element) {
        this.element = element;
        this.valueChange = new EventEmitter();
        this.display = 'block';
        this.defaults = {
            el: this.element.nativeElement,
            initialValue: '',
            initialEditType: 'wysiwyg',
            previewStyle: 'vertical',
            height: '300px'
        };
    }
    /**
     * @return {?}
     */
    WysiwygMdEditorDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var options = Object.assign(this.defaults, {
            initialValue: this.initialValue || this.defaults.initialValue,
            initialEditType: this.editType || this.defaults.initialEditType,
            height: this.height || this.defaults.height,
            previewStyle: this.previewStyle || this.defaults.previewStyle,
        });
        this.editor = new Editor(options);
        this.editor.on('change', (/**
         * @return {?}
         */
        function () {
            _this.valueChange.emit(_this.editor.getValue());
        }));
    };
    /**
     * @return {?}
     */
    WysiwygMdEditorDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.editor.off('change');
        this.editor.remove();
    };
    WysiwygMdEditorDirective.decorators = [
        { type: Directive, args: [{
                    selector: 'ngxWysiwygMdEditor, [ngxWysiwygMdEditor]'
                },] }
    ];
    /** @nocollapse */
    WysiwygMdEditorDirective.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    WysiwygMdEditorDirective.propDecorators = {
        initialValue: [{ type: Input }],
        editType: [{ type: Input }],
        height: [{ type: Input }],
        previewStyle: [{ type: Input }],
        valueChange: [{ type: Output }],
        display: [{ type: HostBinding, args: ['style.display',] }]
    };
    return WysiwygMdEditorDirective;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-wysiwyg-md-editor.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxWysiwygMdEditorModule = /** @class */ (function () {
    function NgxWysiwygMdEditorModule() {
    }
    NgxWysiwygMdEditorModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxWysiwygMdEditorComponent, WysiwygMdEditorDirective],
                    imports: [],
                    exports: [NgxWysiwygMdEditorComponent, WysiwygMdEditorDirective]
                },] }
    ];
    return NgxWysiwygMdEditorModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-wysiwyg-markdown-editor.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxWysiwygMdEditorService, NgxWysiwygMdEditorComponent, WysiwygMdEditorDirective, NgxWysiwygMdEditorModule };

//# sourceMappingURL=ngx-wysiwyg-markdown-editor.js.map