import { OnInit, OnDestroy, EventEmitter, ElementRef } from '@angular/core';
import Editor from 'tui-editor';
export declare class WysiwygMdEditorDirective implements OnInit, OnDestroy {
    private element;
    editor: Editor;
    defaults: any;
    initialValue: string;
    editType: string;
    height: string;
    previewStyle: string;
    valueChange: EventEmitter<string>;
    display: string;
    constructor(element: ElementRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
